/// <reference types="node" />
import { Readable } from 'stream';
export declare type MultiStreams = (Readable | (() => Readable))[];
export declare function toStream(content: Buffer | string): Readable;
export declare type File = {
    absPath: string;
    contents: string;
    deps: FileMap;
};
export declare type FileMap = {
    [absPath: string]: File | null;
};
export interface BundleOptions {
    entries: string[];
    cwd: string;
    expand: boolean;
    loadContent: boolean;
    files: FileMap;
}
export declare class Bundle {
    size: number;
    cwd: string;
    rendered: boolean;
    files: {
        [key: string]: string | Buffer | undefined;
    };
    streams: MultiStreams;
    private index;
    constructor({ cwd }?: {
        cwd: string;
    });
    addResource(absoluteFileName: string, content?: Buffer | string): void;
    addEntry(absoluteFileName: string, content?: Buffer | string): Promise<void>;
    fileIndex(): {
        [relativeFilePath: string]: [number, number];
    };
    toStream(): Promise<any>;
}
