"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var util_1 = require("util");
var path_1 = require("path");
var stream_1 = require("stream");
var semaphore_1 = require("@calebboyd/semaphore");
var MultiStream = require("multistream");
var createReadStream = fs.createReadStream, lstat = util_1.promisify(fs.lstat), realpath = util_1.promisify(fs.realpath), stat = util_1.promisify(fs.stat);
function renderSortedObject(entries, streams) {
    return entries.sort().reduce(function (obj, _a) {
        var _b;
        var key = _a[0], value = _a[1];
        streams.push(value.stream);
        value.stream = void 0;
        return Object.assign(obj, (_b = {}, _b[key] = value, _b));
    }, {});
}
function makeRelative(cwd, path) {
    return './' + path_1.relative(cwd, path);
}
function toStream(content) {
    var readable = new stream_1.Readable({
        read: function () {
            this.push(content);
            this.push(null);
        },
    });
    return readable;
}
exports.toStream = toStream;
var Bundle = /** @class */ (function () {
    function Bundle(_a) {
        var cwd = (_a === void 0 ? { cwd: process.cwd() } : _a).cwd;
        this.size = 0;
        this.rendered = false;
        this.files = {};
        this.streams = [];
        this.index = {};
        this.cwd = cwd;
    }
    Bundle.prototype.addResource = function (absoluteFileName, content) {
        this.files[absoluteFileName] = content;
    };
    Bundle.prototype.addEntry = function (absoluteFileName, content) {
        return __awaiter(this, void 0, void 0, function () {
            var length, linkpath, stats, name, existing, start, linkName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        length = 0;
                        linkpath = '';
                        if (!(content !== undefined)) return [3 /*break*/, 1];
                        length = Buffer.byteLength(content);
                        return [3 /*break*/, 6];
                    case 1: return [4 /*yield*/, lstat(absoluteFileName)];
                    case 2:
                        stats = _a.sent();
                        if (!stats.isSymbolicLink()) return [3 /*break*/, 5];
                        linkpath = absoluteFileName;
                        return [4 /*yield*/, realpath(linkpath)];
                    case 3:
                        absoluteFileName = _a.sent();
                        return [4 /*yield*/, stat(linkpath)];
                    case 4:
                        stats = _a.sent();
                        _a.label = 5;
                    case 5:
                        length = stats.size;
                        _a.label = 6;
                    case 6:
                        name = makeRelative(this.cwd, absoluteFileName), existing = this.index[name];
                        if (!existing) {
                            start = this.size;
                            this.size += length;
                            this.index[name] = [start, length];
                        }
                        if (linkpath) {
                            linkName = makeRelative(this.cwd, absoluteFileName);
                            this.index[linkName] = this.index[name];
                        }
                        if (!existing) {
                            ;
                            this.index[name].stream = function () {
                                return content ? toStream(content) : createReadStream(absoluteFileName);
                            };
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Bundle.prototype.fileIndex = function () {
        if (!this.rendered) {
            throw new Error('Index not rendered must call toStream() first');
        }
        return this.index;
    };
    Bundle.prototype.toStream = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.files;
                        return [4 /*yield*/, semaphore_1.each(Object.keys(this.files), function (key) {
                                return _this.addEntry(key, _this.files[key]);
                            }, { concurrency: 10 })];
                    case 1:
                        _a.sent();
                        this.index = renderSortedObject(Object.entries(this.index), this.streams);
                        this.rendered = true;
                        return [2 /*return*/, new MultiStream(this.streams)];
                }
            });
        });
    };
    return Bundle;
}());
exports.Bundle = Bundle;
